Spine.Content = (function() {
	"use strict";

	var RULESENGINETOPIC = '$SYS/rulesengine/rules';
	if (typeof Spine.WebDemo !== 'undefined' && Spine.WebDemo === true) {
		RULESENGINETOPIC = 'Spine.WebDemo/rulesengine/rules';
	}

	//-----------------------------------------------------------
	$(window).bind('beforeunload', function() {
		Spine.Mqtt.disconnect();
	});

	//-----------------------------------------------------------
	function init() {
		Spine.Editor.init();
		Spine.Mqtt.init();
		Spine.Mqtt.connect();
	};

	function onConnect() {
	};

	function onMessageArrived(topic, payload) {
		if (topic === RULESENGINETOPIC) {
			Spine.Mqtt.unsubscribe(RULESENGINETOPIC);
			Spine.Editor.Flowchart.loadRules(payload);
		}
	};

	//-----------------------------------------------------------
	function initAfterSensorsMenuLoaded() {
	};

	function goToSensorsPage(loc, type) {
		$.cookie('menu_loc', loc);
		$.cookie('menu_type', type);
		$(location).attr('href', 'sensors.html');
	};

	function initAfterActuatorsMenuLoaded() {
	};

	function goToActuatorsPage(loc, type) {
		$.cookie('menu_loc', loc);
		$.cookie('menu_type', type);
		$(location).attr('href', 'actuators.html');
	};

	//-----------------------------------------------------------
	function createEditorMenu() {
		var $menu = $('#editor-menu');

		$menu.empty();
		$menu.attr({'class': 'active dropdown'});
		$menu.append($('<a/>')
			.attr({
				'href': '#',
				'class': 'dropdown-toggle',
				'data-toggle': 'dropdown'
			})
			.html('Rules Editor <b class="caret"></b>'));

		var $ul = $('<ul/>').attr({'class': 'dropdown-menu'});

		$ul.append($('<li/>').append($('<a/>').attr('href', "javascript:Spine.Content.loadRules();").text('Load')));
		$ul.append($('<li/>').append($('<a/>').attr('href', "javascript:Spine.Content.deployRules();").text('Deploy')));
		$ul.append($('<li/>').attr('class', 'divider'));
		$ul.append($('<li/>').append($('<a/>').attr('href', "javascript:Spine.Content.importRules();").text('Import')));
		$ul.append($('<li/>').append($('<a/>').attr('href', "javascript:Spine.Content.exportRules();").text('Export')));

		$menu.append($ul);
	};

	function loadRules() {
		var rules = Spine.Editor.Flowchart.saveRules();
		if (rules.emptyRules === true) {
			Spine.Mqtt.subscribe(RULESENGINETOPIC, {qos: 1});
		} else {
			Spine.Editor.Modal.showConfirmLoadDialog();
		}
	};

	function deployRules() {
		var rules = Spine.Editor.Flowchart.saveRules();
		if (rules.emptyRules === true) {
			Spine.Editor.Modal.showConfirmDeployDialog(rules.strRules);
		} else {
			Spine.Mqtt.publish(RULESENGINETOPIC, rules.strRules, true);
		}
	};

	function exportRules() {
		var rules = Spine.Editor.Flowchart.saveRules();
		Spine.Editor.Modal.showExportDialog(rules.strRules);
	};

	function importRules() {
		Spine.Editor.Modal.showImportDialog();
	};

	//-----------------------------------------------------------
	return {
		RULESENGINETOPIC:             RULESENGINETOPIC,
		init:                         init,
		onConnect:                    onConnect,
		onMessageArrived:             onMessageArrived,
		initAfterSensorsMenuLoaded:   initAfterSensorsMenuLoaded,
		goToSensorsPage:              goToSensorsPage,
		initAfterActuatorsMenuLoaded: initAfterActuatorsMenuLoaded,
		goToActuatorsPage:            goToActuatorsPage,
		createMenu:                   createEditorMenu,
		loadRules:                    loadRules,
		deployRules:                  deployRules,
		exportRules:                  exportRules,
		importRules:                  importRules
	};
})();
