var Spine = (function() {
	"use strict";

	//-----------------------------------------------------------
	// DEBUGGING
	var Debugging = false;
	// disable crossDomain requests
	if (Debugging === true)
		$.ajaxSetup({ crossDomain: false });

	//-----------------------------------------------------------
	// DEMO
	var WebDemo = false;

	//-----------------------------------------------------------
	function getMqttConnectParams() {
		var host;
		var port       = 8082;
		var clientId   = 'Spine.WebUI';
		var randomLong = Math.floor(Math.random() * 4294967295); // 2^32

		if (WebDemo === true) {
			host = 'pilinc';
			port = 8082;
			clientId = 'Spine.WebDemo.' + randomLong.toString();
		} else {
			if (Debugging === true) {
				host = '127.0.0.1';
			} else {
				host = document.location.hostname;
			}
		}

		return {host: host, port: port, clientId: clientId, cleanSession: true, useSSL: false};
	}

	//-----------------------------------------------------------
	function getWebServerUrl() {
		var url;

		if (Debugging === true) {
			url = document.location.href;
			url = url.slice(0, url.lastIndexOf('/') + 1);
		}
		else {
			url = document.location.href;
			url = url.slice(0, url.lastIndexOf('/') + 1);
		}

		return url;
	}

	//-----------------------------------------------------------
	$(function() {
		if (typeof Spine.Navbar !== 'undefined')
			Spine.Navbar.init();
		if (typeof Spine.Content !== 'undefined')
			Spine.Content.init();
	});

	//-----------------------------------------------------------
	return {
		Debugging:            Debugging,
		WebDemo:              WebDemo,
		getMqttConnectParams: getMqttConnectParams,
		getWebServerUrl:      getWebServerUrl
	};
})();
